## visad.java3d
Class ShadowTupleTypeJ3D

    java.lang.Object
      visad.ShadowType
          visad.java3d.ShadowTypeJ3D
              visad.java3d.ShadowTupleTypeJ3D

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  ShadowBarbTupleTypeJ3D, ShadowNodeTupleTypeJ3D, ShadowRealTupleTypeJ3D

public class ShadowTupleTypeJ3D
extends ShadowTypeJ3D

The ShadowTupleTypeJ3D class shadows the TupleType class, within a DataDisplayLink.

See Also:
  Serialized Form

Field Summary
`(package private) ShadowTypeJ3D[]` `tupleComponents`

Fields inherited from class visad.java3d.ShadowTypeJ3D
`adaptedShadowType, display, inheritedText, inheritedTextControl, Link, projListener, Type`

Fields inherited from class visad.ShadowType
`LEGAL, METERS_PER_DEGREE, NESTED, NOTHING_MAPPED, SIMPLE_ANIMATE_FIELD, SIMPLE_FIELD, SIMPLE_TUPLE`

Constructor Summary
`ShadowTupleTypeJ3D(MathType t, DataDisplayLink link, ShadowType parent)`

Method Summary
`boolean` `doTransform(Object group, Data data, float[] value_array, float[] default_values, DataRenderer renderer)` transform data into a Java3D scene graph; return true if need post-process
`ShadowType` `getComponent(int i)`
`int` `getDimension()` get number of components
`(package private) boolean` `isFlat()`
`void` `postProcess(Object group)` render accumulated Vector of value_array-s to and add to group; then clear AccumulationVector
`void` `preProcess()` clear AccumulationVector
`boolean` `recurseComponent(int i, Object group, Data data, float[] value_array, float[] default_values, DataRenderer renderer)`

Methods inherited from class visad.java3d.ShadowTypeJ3D

`addLabelsToGroup, addTextToGroup, addToGroup, allowConstantColorSurfaces, assembleColor, assembleFlow, assembleSelect, assembleShape, assembleSpatial, checkIndices, ensureNotEmpty, ensureNotEmpty, getAdaptedParent, getAdaptedShadowType, getComponents, getData, getDisplay, getDisplayIndices, getLevelOfDifficulty, getMappedDisplayScalar, getMultipleDisplayScalar, getParentText, getParentTextControl, getType, getValueIndices, makeAppearance, makeContour, makeFlow, makePointGeometry, makeStreamline, makeText, mapValues, mapValues, mapValues, setText, staticMakeAppearance, terminalTupleOrScalar, toString`

Methods inherited from class visad.ShadowType

`addSwitch, addToGroup, addToSwitch, adjustFlowToEarth, adjustZ, allowCurvedTexture, allowLinearContour, byteToFloat, floatToByte, getAdjustProjectionSeam, getAnyContour, getAnyFlow, getAnyShape, getAnyText, getComponentIndex, getComponentWithRef, getCurvedTexture, getDefaultColorIndex, getIsLinearContour3D, getIsTerminal, getIsTexture3D, getIsTextureMap, getLink, getMultipleSpatialDisplayScalar, getRefToComponent, getTextMaps, makeBranch, makePointGeometry, makeSpatialSet, makeSwitch, recurseRange, setTex3DCoords, setTexCoords, setTexStackCoords, terminalTupleOrScalar, texture3DToGroup, textureDepth, textureHeight, textureStackToGroup, textureToGroup, textureWidth, wantIndexed`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### tupleComponents

    ShadowTypeJ3D[] tupleComponents

Constructor Detail

### ShadowTupleTypeJ3D

    public ShadowTupleTypeJ3D(MathType t,
                              DataDisplayLink link,
                              ShadowType parent)
                       throws VisADException,
                              RemoteException

Method Detail

### getDimension

    public int getDimension()

  get number of components

### getComponent

    public ShadowType getComponent(int i)

### isFlat

    boolean isFlat()

### preProcess

    public void preProcess()
                    throws VisADException

  clear AccumulationVector

  Overrides:
    `preProcess` in class `ShadowTypeJ3D`
  Throws:
    `VisADException`

### doTransform

    public boolean doTransform(Object group,
                               Data data,
                               float[] value_array,
                               float[] default_values,
                               DataRenderer renderer)
                        throws VisADException,
                               RemoteException

  transform data into a Java3D scene graph; return true if need post-process

  Overrides:
    `doTransform` in class `ShadowTypeJ3D`
  Throws:
    `VisADException`
    `RemoteException`

### recurseComponent

    public boolean recurseComponent(int i,
                                    Object group,
                                    Data data,
                                    float[] value_array,
                                    float[] default_values,
                                    DataRenderer renderer)
                             throws VisADException,
                                    RemoteException

  Overrides:
    `recurseComponent` in class `ShadowType`
  Throws:
    `VisADException`
    `RemoteException`

### postProcess

    public void postProcess(Object group)
                     throws VisADException

  render accumulated Vector of value_array-s to and add to group; then clear AccumulationVector

  Overrides:
    `postProcess` in class `ShadowTypeJ3D`
  Throws:
    `VisADException`